﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PTMedicalInsurance.Entity
{
    /// <summary>
    /// 【2304】住院结算
    /// 交易说明：通过此交易进行住院正式结算。
    /// </summary>
    public class InpatientSettlementInput
    {
        /// <summary>
        /// 人员编号
        /// </summary>
        public string psn_no { get; set; }

        /// <summary>
        /// 就诊凭证类型
        /// </summary>
        public string mdtrt_cert_type { get; set; }

        /// <summary>
        /// 就诊凭证编号
        /// 就诊凭证类型为“01”时填写电子凭证令牌，
        /// 为“02”时填写身份证号，为“03”时填写社会保障卡卡号
        /// </summary>
        public string mdtrt_cert_no { get; set; }

        /// <summary>
        /// 医疗费总额
        /// </summary>
        public decimal medfee_sumamt { get; set; }

        /// <summary>
        /// 个人结算方式
        /// </summary>
        public string psn_setlway { get; set; }

        /// <summary>
        /// 就诊 ID
        /// </summary>
        public string mdtrt_id { get; set; }

        /// <summary>
        /// 险种类型
        /// </summary>
        public string insutype { get; set; }

        /// <summary>
        /// 个人账户使用标志
        /// </summary>
        public string acct_used_flag { get; set; }

        /// <summary>
        /// 发票号
        /// </summary>
        public string invono { get; set; }

        /// <summary>
        /// 中途结算标志
        /// </summary>
        public string mid_setl_flag { get; set; }

        /// <summary>
        /// 全自费金额
        /// </summary>
        public decimal fulamt_ownpay_amt { get; set; }

        /// <summary>
        /// 超限价金额
        /// </summary>
        public decimal overlmt_selfpay { get; set; }

        /// <summary>
        /// 先行自付金额
        /// </summary>
        public decimal preselfpay_amt { get; set; }

        /// <summary>
        /// 符合政策范围金额
        /// </summary>
        public decimal inscp_scp_amt { get; set; }
    }

    /// <summary>
    /// 输出-结算信息
    /// </summary>
    public class InpatientSettlementInfoOutput:InpatientPreSettlementInfoOutput
    {
        /// <summary>
        /// 结算 ID
        /// </summary>
        public string setl_id { get; set; }
    }

}
