﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PTMedicalInsurance.Entity
{

    /// <summary>
    /// 【2503】人员慢特病备案
    /// 交易说明：通过此交易上传人员慢特病备案信息。
    /// </summary>
    public class ChronicDiseaseRecordInput:EntityBase
    {
        /// <summary>
        /// 人员编号
        /// </summary>
        [Column("PersonnelNO")]
        public string psn_no { get; set; }

        /// <summary>
        /// 险种类型
        /// </summary>
        [Column("Insutype")]
        public string insutype { get; set; }

        /// <summary>
        /// 门慢门特病种目录代码
        /// </summary>
        [Column("ChronicDiseaseCode")]
        public string opsp_dise_code { get; set; }

        /// <summary>
        /// 门慢门特病种名称
        /// </summary>
        [Column("ChronicDiseaseDesc")]
        public string opsp_dise_name { get; set; }

        /// <summary>
        /// 联系电话
        /// </summary>
        [Column("Telephone")]
        public string tel { get; set; }

        /// <summary>
        /// 联系地址
        /// </summary>
        [Column("Address")]
        public string addr { get; set; }

        /// <summary>
        /// 参保机构医保区划
        /// </summary>
        [Column("InsuranceAreaCode")]
        public string insu_optins { get; set; }

        /// <summary>
        /// 鉴定定点医药机构编号
        /// </summary>
        [Column("BusinHospCode")]
        public string ide_fixmedins_no { get; set; }

        /// <summary>
        /// 鉴定定点医药机构名称
        /// </summary>
        [Column("BusinHospDesc")]
        public string ide_fixmedins_name { get; set; }

        /// <summary>
        /// 医院鉴定日期
        /// </summary>
        [Column("BusinDate")]
        public DateTime hosp_ide_date { get; set; }

        /// <summary>
        /// 诊断医师编码
        /// </summary>
        [Column("DoctorCode")]
        public string diag_dr_code { get; set; }

        /// <summary>
        /// 诊断医师姓名
        /// </summary>
        [Column("DoctorDesc")]
        public string diag_dr_name { get; set; }

        /// <summary>
        /// 开始日期
        /// </summary>
        [Column("BusinStartDate")]
        public DateTime begndate { get; set; }

        /// <summary>
        /// 结束日期
        /// </summary>
        [Column("BusinEndDate")]
        public DateTime? enddate { get; set; }
    }

    /// <summary>
    /// 【2503】人员慢特病备案
    /// 输出类
    /// </summary>
    public class ChronicDiseaseRecordOutput
    {
        /// <summary>
        /// 待遇申报明细流水号
        /// </summary>
        [Column("DeclareNo")]
        public string trt_dcla_detl_sn { get; set; }
    }

}
