﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PTMedicalInsurance.Entity
{
    /// <summary>
    /// 【2501】转院备案
    /// 交易说明：通过此交易上传转院备案信息。
    /// </summary>
    public class PersonFixedPointRecord: EntityBase
    {
        [Column("PersonnelNO")]
        public string psn_no { get; set; } // 人员编号

        [Column("Insutype")]
        public string insutype { get; set; } // 险种类型

        [Column("Telephone")]
        public string tel { get; set; } // 联系电话

        [Column("Address")]
        public string addr { get; set; } // 联系地址

        [Column("InsuranceAreaCode")]
        public string insu_optins { get; set; } // 参保机构医保区划

        [Column("Diagcode")]
        public string diag_code { get; set; } // 诊断代码

        [Column("DiagDesc")]
        public string diag_name { get; set; } // 诊断名称

        [Column("DiseDesc")]
        public string dise_cond_dscr { get; set; } // 疾病病情描述

        [Column("BusinHospCode")]
        public string reflin_medins_no { get; set; } // 转往定点医药机构编号

        [Column("BusinHospDesc")]
        public string reflin_medins_name { get; set; } // 转往医院名称

        [Column("AreaCode")]
        public string mdtrtarea_admdvs { get; set; } // 就医地行政区划

        [Column("HospAgreeFlag")]
        public string hosp_agre_refl_flag { get; set; } // 医院同意转院标志

        [Column("ReflType")]
        public string refl_type { get; set; } // 转院类型

        [Column("BusinDate")]
        public string refl_date { get; set; } // 转院日期

        [Column("ReflReason")]
        public string refl_rea { get; set; } // 转院原因

        [Column("ReflOpinion")]
        public string refl_opnn { get; set; } // 转院意见

        [Column("BusinStartDate")]
        public string begndate { get; set; } // 开始日期

        [Column("BusinEndDate")]
        public string enddate { get; set; } // 结束日期

        [Column("ReflUsedFlag")]
        public string refl_used_flag { get; set; } // 转诊使用标志
    }

    /// <summary>
    /// 【2501】转院备案
    /// 输出类（无输出定义）
    /// </summary>
    public class HospitalTransferRecordOutput
    {
        /// <summary>
        /// 待遇申报明细流水号
        /// </summary>
        public string trt_dcla_detl_sn { get; set; }
    }

}
