﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PTMedicalInsurance.Entity
{
    /// <summary>
    /// 【2505】人员定点备案
    /// 交易说明：通过此交易上传人员定点备案信息。
    /// </summary>
    public class PersonFixedPointRecordInput:EntityBase
    {
        /// <summary>
        /// 人员编号
        /// </summary>
        [Column("PersonnelNO")]
        public string psn_no { get; set; }

        /// <summary>
        /// 联系电话
        /// </summary>
        [Column("Telephone")]
        public string tel { get; set; }

        /// <summary>
        /// 联系地址
        /// </summary>
        [Column("Address")]
        public string addr { get; set; }

        /// <summary>
        /// 业务申请类型
        /// </summary>
        [Column("BusinAppyType")]
        public string biz_appy_type { get; set; }

        /// <summary>
        /// 开始日期
        /// </summary>
        [Column("BusinStartDate")]
        public string begndate { get; set; }

        /// <summary>
        /// 结束日期
        /// </summary>
        [Column("BusinEndDate")]
        public string enddate { get; set; }

        /// <summary>
        /// 代办人姓名
        /// </summary>
        [Column("AgnterName")]
        public string agnter_name { get; set; }

        /// <summary>
        /// 代办人证件类型
        /// </summary>
        [Column("AgnterCertType")]
        public string agnter_cert_type { get; set; }

        /// <summary>
        /// 代办人证件号码
        /// </summary>
        [Column("AgnterCertNo")]
        public string agnter_certno { get; set; }

        /// <summary>
        /// 代办人联系方式
        /// </summary>
        [Column("AgnterTelephone")]
        public string agnter_tel { get; set; }

        /// <summary>
        /// 代办人联系地址
        /// </summary>
        [Column("AgnterAddress")]
        public string agnter_addr { get; set; }

        /// <summary>
        /// 代办人关系
        /// </summary>
        [Column("AgnterRelation")]
        public string agnter_rlts { get; set; }

        /// <summary>
        /// 定点排序号
        /// </summary>
        [Column("FixedNo")]
        public string fix_srt_no { get; set; }

        /// <summary>
        /// 定点医药机构编号
        /// </summary>
        [Column("BusinHospCode")]
        public string fixmedins_code { get; set; }

        /// <summary>
        /// 定点医药机构名称
        /// </summary>
        [Column("BusinHospDesc")]
        public string fixmedins_name { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [Column("Memo")]
        public string memo { get; set; }


        /// <summary>
        /// 就医点类型
        /// </summary>
        public string fix_local_type { get; set; }

        /// <summary>
        /// 主辅标志
        /// </summary>
        public string fix_main_scd_flag { get; set; }
    }

    /// <summary>
    /// 【2505,90210】人员定点备案
    /// 输出类
    /// </summary>
    public class PersonFixedPointRecordOutput
    {
        /// <summary>
        /// 待遇申报明细流水号
        /// </summary>
        public string trt_dcla_detl_sn { get; set; }
    }

    /// <summary>
    /// 【2505】人员定点备案
    /// 输出类
    /// </summary>
    public class PersonFixedPointAlterInput 
    {
        /// <summary>
        /// 人员编号
        /// </summary>
        [Column("PersonnelNO")]
        public string psn_no { get; set; }

        /// <summary>
        /// 开始日期
        /// </summary>
        [Column("BusinStartDate")]
        public string begndate { get; set; }

        /// <summary>
        /// 结束日期
        /// </summary>
        [Column("BusinEndDate")]
        public string enddate { get; set; }

        /// <summary>
        /// 定点事件类型
        /// </summary>
        public string fix_evt_type { get; set; }

        /// <summary>
        /// 主辅标志
        /// </summary>
        public string fix_main_scd_flag { get; set; }

        /// <summary>
        /// 就医点类型
        /// </summary>
        public string fix_local_type { get; set; }

        /// <summary>
        /// 定点医药机构编号
        /// </summary>
        [Column("BusinHospCode")]
        public string fixmedins_code { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [Column("Memo")]
        public string memo { get; set; }
    }


}
