﻿using System;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel;
using System.Data.Linq;
using System.Data.Linq.Mapping;

namespace PTMedicalInsurance.Entity.Base.Settlement.Record
{

    public class QueryChronicDiseaseRecord :EntityBase
    {
        /// <summary>
        /// 待遇申报明细流水号
        /// </summary>
        [Column(Name = "TrtDclaDetlSN", CanBeNull  = true,DbType = "VarChar(50)")]
        [StringLength(50)]
        [DisplayName("待遇申报明细流水号")]
        public string trt_dcla_detl_sn { get; set; }

        /// <summary>
        /// 人员编号
        /// </summary>
        [Column(Name = "PsnNo", DbType = "VarChar(30)")]
        [StringLength(30)]
        [DisplayName("人员编号")]
        public string psn_no { get; set; }

        /// <summary>
        /// 人员证件类型
        /// </summary>
        [Column(Name = "PsnCertType", DbType = "VarChar(6)")]
        [StringLength(6)]
        [DisplayName("人员证件类型")]
        public string psn_cert_type { get; set; }

        /// <summary>
        /// 证件号码
        /// </summary>
        [Column(Name = "Certno", DbType = "VarChar(50)")]
        [StringLength(50)]
        [DisplayName("证件号码")]
        public string certno { get; set; }

        /// <summary>
        /// 人员姓名
        /// </summary>
        [Column(Name = "PsnName", DbType = "VarChar(50)")]
        [StringLength(50)]
        [DisplayName("人员姓名")]
        public string psn_name { get; set; }

        /// <summary>
        /// 定点医药机构编号
        /// </summary>
        [Column(Name = "FixmedinsCode", DbType = "VarChar(30)")]
        [StringLength(30)]
        [DisplayName("定点医药机构编号")]
        public string fixmedins_code { get; set; }

        /// <summary>
        /// 定点医药机构名称
        /// </summary>
        [Column(Name = "FixmedinsName", DbType = "VarChar(200)")]
        [StringLength(200)]
        [DisplayName("定点医药机构名称")]
        public string fixmedins_name { get; set; }

        /// <summary>
        /// 主诊医师代码
        /// </summary>
        [Column(Name = "DiagDrCode", DbType = "VarChar(30)")]
        [StringLength(30)]
        [DisplayName("主诊医师代码")]
        public string diag_dr_code { get; set; }

        /// <summary>
        /// 主诊医师姓名
        /// </summary>
        [Column(Name = "DiagDrName", DbType = "VarChar(50)")]
        [StringLength(50)]
        [DisplayName("主诊医师姓名")]
        public string diag_dr_name { get; set; }

        /// <summary>
        /// 开始日期
        /// </summary>
        [Column(Name = "Begndate", DbType = "Date")]
        [DisplayName("开始日期")]
        public DateTime? begndate { get; set; }

        /// <summary>
        /// 结束日期
        /// </summary>
        [Column(Name = "Enddate", DbType = "Date")]
        [DisplayName("结束日期")]
        public DateTime? enddate { get; set; }

        /// <summary>
        /// 申请日期
        /// </summary>
        [Column(Name = "Appydate", DbType = "Date")]
        [DisplayName("申请日期")]
        public DateTime? appydate { get; set; }

        /// <summary>
        /// 申请理由
        /// </summary>
        [Column(Name = "AppyRea", DbType = "VarChar(1000)")]
        [StringLength(1000)]
        [DisplayName("申请理由")]
        public string appy_rea { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [Column(Name = "Memo", DbType = "VarChar(500)")]
        [StringLength(500)]
        [DisplayName("备注")]
        public string memo { get; set; }

        /// <summary>
        /// 代办人姓名
        /// </summary>
        [Column(Name = "AgnterName", DbType = "VarChar(50)")]
        [StringLength(50)]
        [DisplayName("代办人姓名")]
        public string agnter_name { get; set; }

        /// <summary>
        /// 代办人证件类型
        /// </summary>
        [Column(Name = "AgnterCertType", DbType = "VarChar(6)")]
        [StringLength(6)]
        [DisplayName("代办人证件类型")]
        public string agnter_cert_type { get; set; }

        /// <summary>
        /// 代办人证件号码
        /// </summary>
        [Column(Name = "AgnterCertno", DbType = "VarChar(50)")]
        [StringLength(50)]
        [DisplayName("代办人证件号码")]
        public string agnter_certno { get; set; }

        /// <summary>
        /// 代办人电话
        /// </summary>
        [Column(Name = "AgnterTel", DbType = "VarChar(30)")]
        [StringLength(30)]
        [DisplayName("代办人电话")]
        public string agnter_tel { get; set; }

        /// <summary>
        /// 代办人关系
        /// </summary>
        [Column(Name = "AgnterRlts", DbType = "VarChar(3)")]
        [StringLength(3)]
        [DisplayName("代办人关系")]
        public string agnter_rlts { get; set; }

        /// <summary>
        /// 代办人联系地址
        /// </summary>
        [Column(Name = "AgnterAddr", DbType = "VarChar(200)")]
        [StringLength(200)]
        [DisplayName("代办人联系地址")]
        public string agnter_addr { get; set; }

        /// <summary>
        /// 有效标志
        /// </summary>
        [Column(Name = "ValiFlag", DbType = "VarChar(3)")]
        [StringLength(3)]
        [DisplayName("有效标志")]
        public string vali_flag { get; set; }

        /// <summary>
        /// 险种类型
        /// </summary>
        [Column(Name = "Insutype", DbType = "VarChar(6)")]
        [StringLength(6)]
        [DisplayName("险种类型")]
        public string insutype { get; set; }

        /// <summary>
        /// 单位编号
        /// </summary>
        [Column(Name = "EmpNo", DbType = "VarChar(40)")]
        [StringLength(40)]
        [DisplayName("单位编号")]
        public string emp_no { get; set; }

        /// <summary>
        /// 单位名称
        /// </summary>
        [Column(Name = "EmpName", DbType = "VarChar(200)")]
        [StringLength(200)]
        [DisplayName("单位名称")]
        public string emp_name { get; set; }

        /// <summary>
        /// 事件流水号
        /// </summary>
        [Column(Name = "Evtsn", DbType = "VarChar(50)")]
        [StringLength(50)]
        [DisplayName("事件流水号")]
        public string evtsn { get; set; }

        /// <summary>
        /// 认定定点医药机构名称
        /// </summary>
        [Column(Name = "IdeFixmedinsName", DbType = "VarChar(30)")]
        [StringLength(30)]
        [DisplayName("认定定点医药机构名称")]
        public string ide_fixmedins_name { get; set; }

        /// <summary>
        /// 认定顶点医药机构编号
        /// </summary>
        [Column(Name = "IdeFixmedinsNo", DbType = "VarChar(200)")]
        [StringLength(200)]
        [DisplayName("认定顶点医药机构编号")]
        public string ide_fixmedins_no { get; set; }

        /// <summary>
        /// 病种编码
        /// </summary>
        [Column(Name = "OpSpDiseCode", DbType = "VarChar(30)")]
        [StringLength(30)]
        [DisplayName("病种编码")]
        public string opsp_dise_code { get; set; }

        /// <summary>
        /// 病种名称
        /// </summary>
        [Column(Name = "OpSpDiseName", DbType = "VarChar(300)")]
        [StringLength(300)]
        [DisplayName("病种名称")]
        public string opsp_dise_name { get; set; }

        /// <summary>
        /// 主病种
        /// </summary>
        [Column(Name = "MainDise", DbType = "VarChar(6)")]
        [StringLength(6)]
        [DisplayName("主病种")]
        public string main_dise { get; set; }
    }

}
