﻿using System;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Collections.Generic;

namespace PTMedicalInsurance.Entity.Base.Settlement.Record
{
    public class QueryFamilyDoctorRecord : EntityBase
    {
        /// <summary>
        /// 待遇申报明细流水号
        /// </summary>
        [Column(Name = "trt_dcla_detl_sn", CanBeNull = true, DbType = "VarChar(30)")]
        [StringLength(30)]
        [DisplayName("待遇申报明细流水号")]
        public string trt_dcla_detl_sn { get; set; }

        /// <summary>
        /// 人员编号
        /// </summary>
        [Column(Name = "psn_no", CanBeNull = true, DbType = "VarChar(30)")]
        [StringLength(30)]
        [DisplayName("人员编号")]
        public string psn_no { get; set; }

        /// <summary>
        /// 人员证件类型
        /// </summary>
        [Column(Name = "psn_cert_type", CanBeNull = true, DbType = "VarChar(6)")]
        [StringLength(6)]
        [DisplayName("人员证件类型")]
        public string psn_cert_type { get; set; }

        /// <summary>
        /// 证件号码
        /// </summary>
        [Column(Name = "certno", CanBeNull = true, DbType = "VarChar(50)")]
        [StringLength(50)]
        [DisplayName("证件号码")]
        public string certno { get; set; }

        /// <summary>
        /// 人员姓名
        /// </summary>
        [Column(Name = "psn_name", CanBeNull = true, DbType = "VarChar(50)")]
        [StringLength(50)]
        [DisplayName("人员姓名")]
        public string psn_name { get; set; }

        /// <summary>
        /// 定点医药机构编号
        /// </summary>
        [Column(Name = "fixmedins_code", CanBeNull = true, DbType = "VarChar(30)")]
        [StringLength(30)]
        [DisplayName("定点医药机构编号")]
        public string fixmedins_code { get; set; }

        /// <summary>
        /// 定点医药机构名称
        /// </summary>
        [Column(Name = "fixmedins_name", CanBeNull = true, DbType = "VarChar(200)")]
        [StringLength(200)]
        [DisplayName("定点医药机构名称")]
        public string fixmedins_name { get; set; }

        /// <summary>
        /// 医师代码
        /// </summary>
        [Column(Name = "dr_code", CanBeNull = true, DbType = "VarChar(30)")]
        [StringLength(30)]
        [DisplayName("医师代码")]
        public string dr_code { get; set; }

        /// <summary>
        /// 医师姓名
        /// </summary>
        [Column(Name = "dr_name", CanBeNull = true, DbType = "VarChar(50)")]
        [StringLength(50)]
        [DisplayName("医师姓名")]
        public string dr_name { get; set; }

        /// <summary>
        /// 开始日期
        /// </summary>
        [Column(Name = "begndate", CanBeNull = true, DbType = "DateTime")]
        [DisplayName("开始日期")]
        public DateTime? begndate { get; set; }

        /// <summary>
        /// 结束日期
        /// </summary>
        [Column(Name = "enddate", CanBeNull = true, DbType = "DateTime")]
        [DisplayName("结束日期")]
        public DateTime? enddate { get; set; }

        /// <summary>
        /// 签约承诺
        /// </summary>
        [Column(Name = "sign_prse", CanBeNull = true, DbType = "VarChar(200)")]
        [StringLength(200)]
        [DisplayName("签约承诺")]
        public string sign_prse { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        [Column(Name = "memo", CanBeNull = true, DbType = "VarChar(500)")]
        [StringLength(500)]
        [DisplayName("备注")]
        public string memo { get; set; }

        /// <summary>
        /// 代办人姓名
        /// </summary>
        [Column(Name = "agnter_name", CanBeNull = true, DbType = "VarChar(50)")]
        [StringLength(50)]
        [DisplayName("代办人姓名")]
        public string agnter_name { get; set; }

        /// <summary>
        /// 代办人证件类型
        /// </summary>
        [Column(Name = "agnter_cert_type", CanBeNull = true, DbType = "VarChar(6)")]
        [StringLength(6)]
        [DisplayName("代办人证件类型")]
        public string agnter_cert_type { get; set; }

        /// <summary>
        /// 代办人证件号码
        /// </summary>
        [Column(Name = "agnter_certno", CanBeNull = true, DbType = "VarChar(50)")]
        [StringLength(50)]
        [DisplayName("代办人证件号码")]
        public string agnter_certno { get; set; }

        /// <summary>
        /// 代办人电话
        /// </summary>
        [Column(Name = "agnter_tel", CanBeNull = true, DbType = "VarChar(30)")]
        [StringLength(30)]
        [DisplayName("代办人电话")]
        public string agnter_tel { get; set; }

        /// <summary>
        /// 代办人关系
        /// </summary>
        [Column(Name = "agnter_rlts", CanBeNull = true, DbType = "VarChar(3)")]
        [StringLength(3)]
        [DisplayName("代办人关系")]
        public string agnter_rlts { get; set; }

        /// <summary>
        /// 代办人联系地址
        /// </summary>
        [Column(Name = "agnter_addr", CanBeNull = true, DbType = "VarChar(200)")]
        [StringLength(200)]
        [DisplayName("代办人联系地址")]
        public string agnter_addr { get; set; }

        /// <summary>
        /// 有效标志
        /// </summary>
        [Column(Name = "vali_flag", CanBeNull = true, DbType = "VarChar(3)")]
        [StringLength(3)]
        [DisplayName("有效标志")]
        public string vali_flag { get; set; }

        /// <summary>
        /// 险种类型
        /// </summary>
        [Column(Name = "insu_type", CanBeNull = true, DbType = "VarChar(6)")]
        [StringLength(6)]
        [DisplayName("险种类型")]
        public string insu_type { get; set; }

        /// <summary>
        /// 单位编号
        /// </summary>
        [Column(Name = "emp_no", CanBeNull = true, DbType = "VarChar(40)")]
        [StringLength(40)]
        [DisplayName("单位编号")]
        public string emp_no { get; set; }

        /// <summary>
        /// 单位名称
        /// </summary>
        [Column(Name = "emp_name", CanBeNull = true, DbType = "VarChar(200)")]
        [StringLength(200)]
        [DisplayName("单位名称")]
        public string emp_name { get; set; }

        /// <summary>
        /// 事件流水号
        /// </summary>
        [Column(Name = "evtsn", CanBeNull = true, DbType = "VarChar(50)")]
        [StringLength(50)]
        [DisplayName("事件流水号")]
        public string evtsn { get; set; }

        /// <summary>
        /// 签约服务包
        /// </summary>
        [Column(Name = "serv_pack", CanBeNull = true, DbType = "VarChar(6)")]
        [StringLength(6)]
        [DisplayName("签约服务包")]
        public string serv_pack { get; set; }

        /// <summary>
        /// 履约情况列表
        /// </summary>
        public List<FulfillmentDetail> details { get; set; }
    }

    public class FulfillmentDetail : EntityBase
    {
        /// <summary>
        /// 人员编号
        /// </summary>
        [Column(Name = "psn_no", CanBeNull = true, DbType = "VarChar(30)")]
        [StringLength(30)]
        [DisplayName("人员编号")]
        public string psn_no { get; set; }

        /// <summary>
        /// 开始日期
        /// </summary>
        [Column(Name = "begndate", CanBeNull = true, DbType = "DateTime")]
        [DisplayName("开始日期")]
        public DateTime? begndate { get; set; }

        /// <summary>
        /// 结束日期
        /// </summary>
        [Column(Name = "enddate", CanBeNull = true, DbType = "DateTime")]
        [DisplayName("结束日期")]
        public DateTime? enddate { get; set; }

        /// <summary>
        /// 年度
        /// </summary>
        [Column(Name = "year", CanBeNull = true, DbType = "DateTime")]
        [DisplayName("年度")]
        public DateTime? year { get; set; }

        /// <summary>
        /// 有效标志
        /// </summary>
        [Column(Name = "vali_flag", CanBeNull = true, DbType = "VarChar(3)")]
        [StringLength(3)]
        [DisplayName("有效标志")]
        public string vali_flag { get; set; }

        /// <summary>
        /// 履约情况
        /// </summary>
        [Column(Name = "perf_stas", CanBeNull = true, DbType = "VarChar(6)")]
        [StringLength(6)]
        [DisplayName("履约情况")]
        public string perf_stas { get; set; }
    }
}
