﻿using Newtonsoft.Json.Linq;
using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using PTMedicalInsurance.Common;
using PTMedicalInsurance.Helper;
using PTMedicalInsurance.FormSetter;
using PTMedicalInsurance.Business;
using PTMedicalInsurance.Variables;
using FastReport.Data.JsonConnection;
//using Microsoft.Office.Interop.Excel;
using DataTable = System.Data.DataTable;
using System.Threading;

namespace PTMedicalInsurance.Forms
{
    public partial class MedInsuQuery : Form
    {
        DataTable dtExport;
        HisMainBusiness hBus = new HisMainBusiness();
        InvokeHelper invoker = new InvokeHelper();

        //1.声明自适应类实例
        AutoResizeForm asc = new AutoResizeForm();

        public MedInsuQuery()
        {
            InitializeComponent();

            asc.controllInitializeSize(this);
            asc.controlAutoSize(this);
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void MedInsuQuery_Load(object sender, EventArgs e)
        {
            dpST.Text = DateTime.Now.ToString("yyyy-MM-dd 00:00:00");
            dpED.Text = DateTime.Now.ToString("yyyy-MM-dd 23:59:59");

            dt_Begin.Text = DateTime.Now.ToString("yyyy-MM-dd 00:00:00");
            dt_End.Text = DateTime.Now.ToString("yyyy-MM-dd 23:59:59");

            // dgvSettlRecord.AutoGenerateColumns = false;
            GridViewSetter grdSetter = new GridViewSetter();
            grdSetter.SetHeaderTextOfMedInsuHosPerInfo(dgvSettlRecord);
            grdSetter.SetHeaderTextOfPersonDrugApplyInfo(dgvAppyinfo);
            grdSetter.SetHeaderTextOfPersonDrugApplyDetailInfo(dgvMedInsuDirList);
            grdSetter.SetHeaderTextOfPersonDrugApplyHosInfo(dgvFixmedinsList);
            grdSetter.SetHeaderTextOfPerUseDrugInfo(dgvMain);

            grdSetter.DatagridviewColumnWidthAdaptation(dgvSettlRecord);
            //grdSetter.DatagridviewColumnWidthAdaptation(dgvAppyinfo);
            //grdSetter.DatagridviewColumnWidthAdaptation(dgvMedInsuDirList);
            //grdSetter.DatagridviewColumnWidthAdaptation(dgvFixmedinsList);
            grdSetter.DatagridviewColumnWidthAdaptation(dgvMain);
        }

        private void btnQuery_Click(object sender, EventArgs e)
        {
            btnPrint.Enabled = false;
            string sCZYXM = Global.user.name;

            string SqlHeard = " Adm_Dr,MdtrtID,Name as PatientName,Age,PsnCertNO,Gend,PsnType,EmpName,AdmInDepName,insuplcAdmdvs, "
                            + " AdmBed,RegDate,MainDiagName,AttendDoctorNO,ChiefPhyDocName,'"+ sCZYXM+ "' as OpertName,'' as InHospNo,''Address ";                           

            string SqlStrMain = " SELECT a.*,b.*,a.PatientName AS Name,a.PsnType AS PsnTypeCode FROM BS_MIPatCurrentInsuInfo a LEFT JOIN BS_MedInsuRegisterInfo b " 
                              + " ON a.MdtrtID=b.InsuRegID AND a.Interface_Dr=b.Interface_Dr AND a.Hospital_Dr=b.Hospital_Dr "
                              + " WHERE b.Type=1 AND b.ValidFlag=1 AND b.Hospital_Dr= " + Global.inf.hospitalDr + " AND b.Interface_Dr= " + Global.inf.interfaceDr
                              + " AND b.InsuRegID NOT IN (SELECT MdtrtID FROM BS_MedInsuSettlement WHERE MdtrtID=b.InsuRegID AND BillType=1 AND ValidFlag=1 AND AdmType=2) "
                              + " AND b.OccurTime<'" + dpED.Text + "'"  //AND b.OccurTime>'" + dpST.Text + "'
                              + " UNION ALL "
                              + " SELECT a.*,b.*,a.PatientName AS Name,a.PsnType AS PsnTypeCode FROM BS_MIPatCurrentInsuInfo a LEFT JOIN BS_MedInsuRegisterInfo b " 
                              + " ON a.MdtrtID=b.InsuRegID AND a.Interface_Dr=b.Interface_Dr AND a.Hospital_Dr=b.Hospital_Dr "
                              + " LEFT JOIN BS_MedInsuSettlement c ON a.MdtrtID=b.InsuRegID AND b.InsuRegID=c.MdtrtID AND a.Interface_Dr=b.Interface_Dr AND b.Interface_Dr=c.Interface_Dr "
                              + " WHERE b.Type=1 AND b.ValidFlag=1 AND c.BillType=1 AND b.Hospital_Dr= " + Global.inf.hospitalDr + " AND b.Interface_Dr= " + Global.inf.interfaceDr                    
                              + " AND c.AdmType=2 AND c.OccurTime<'" + dpED.Text + "'";  //AND c.OccurTime>'" + dpST.Text + "'

            string sqlStr = " SELECT "+ SqlHeard + " FROM ("+ SqlStrMain +") M ";

            //MessageBox.Show(sqlStr);

            JObject joSqlstr = new JObject();
            joSqlstr.Add("sqlStr", sqlStr);
            joSqlstr.Add("Type", "MedInsuHosPInfo");
            joSqlstr.Add("hospID", Global.inf.hisHospitalDr);
            JArray jaParam = new JArray();
            jaParam.Add(joSqlstr);
            JObject joSettlQuery = new JObject();
            joSettlQuery.Add("params", jaParam);
            joSettlQuery.Add("code", "09010059");

            InvokeHelper invoker = new InvokeHelper();
            JObject joRtn = invoker.invokeInsuService(joSettlQuery.ToString(), "查询结算信息");

            //MessageBox.Show(joRtn.ToString());

            if (joRtn["result"]["data"].ToString() == "[]")
            {
                MessageBox.Show("查询结果为空！");
                return;
            }

            DataTable dt = (DataTable)joRtn["result"]["data"].ToObject(typeof(DataTable));
            dgvSettlRecord.DataSource = dt;

            if (dt.Rows.Count != 0)
            {
                btnPrint.Enabled = true;
                dtExport = dt;

                //从HIS获取患者的床号（分床前医保登记的病人床号没有写入医保平台登记表）
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string BedNo, BedDocName, InHospNo, Address;
                    JObject joTmp = new JObject();
                    joTmp.Add("admID", dt.Rows[i]["Adm_Dr"].ToString());               
                    JObject joRtn2 = invoker.invokeHISService(JsonHelper.setIrisInpar("05110014", joTmp).ToString(), "获取患者就诊信息");
                    if (JsonHelper.parseIrisRtnValue(joRtn2, out string errMsg) == 0)
                    {
                        BedNo = JsonHelper.getDestValue(JObject.Parse(joRtn2.ToString()), "mdtrtinfo.adm_bed");
                        BedDocName = JsonHelper.getDestValue(JObject.Parse(joRtn2.ToString()), "mdtrtinfo.chfpdr_name");
                        InHospNo = JsonHelper.getDestValue(JObject.Parse(joRtn2.ToString()), "mdtrtinfo.medrcdno");
                        Address = JsonHelper.getDestValue(JObject.Parse(joRtn2.ToString()), "mdtrtinfo.Address");
                        dt.Rows[i]["AdmBed"] = BedNo;
                        dt.Rows[i]["AttendDoctorNO"] = BedDocName;
                        dt.Rows[i]["InHospNo"] = InHospNo;
                        dt.Rows[i]["Address"] = Address;
                    }  
                    else
                    {
                        if (errMsg.IndexOf("请重新登录") > 0)                        
                        {
                            MessageBox.Show("获取患者信息失败，请重新登录系统！");
                            break;
                        }
                    }
                }
            }
        }

        private void btnPrint_Click(object sender, EventArgs e)
        {
            string LSH = DateTime.Now.ToString("yyyy-MM-dd"); //DateTime.Now.ToString("MMddHHmmssffff");
            string sFliePathName = @"C:\Users\Administrator\Desktop\" + LSH + "医保在院患者登记或结算信息.xls";  
            string ReturnFileName = ExportToExcel.DataTabletoExcel(dtExport, sFliePathName);
            if (ReturnFileName != "")
            {
                MessageBox.Show("导出成功,文件保存路径：【" + ReturnFileName + "】");
                System.Diagnostics.Process.Start(ReturnFileName); //打开excel文件                
            }
            else
            {
                MessageBox.Show("导出失败!");
            }
        }

        private void btnReadCard_Click(object sender, EventArgs e)
        {
            string outParam, errorMsg;
            //打开读卡窗口，操作员选择读卡类型后进行读卡器读卡，再进行1101获取参保信息
            if (hBus.readCard(out outParam) != 0)
            {                
                MessageBox.Show("读卡失败：" + outParam);
                return;
            }

            //展示患者信息界面
            hBus.showPatInfo(outParam, out outParam);
            //赋值变量
            hBus.setGlobalPatAfaterShowPatInfo(outParam, out outParam);

            JObject joData = new JObject();
            JObject joInput = new JObject();
            joData.Add("psn_no", Global.pat.psn_no);
            joInput.Add("data", joData);

            JObject joRtn = invoker.invokeCenterService("5331", JsonHelper.setCenterInpar("5331", joInput));
            if (JsonHelper.parseCenterRtnValue(joRtn, out errorMsg) != 0)
            {
                MessageBox.Show(" 查询失败：" + errorMsg);
                return;
            }
            else
            {
                if (joRtn["output"]["appyinfo"].ToString() == "[]")
                {
                    MessageBox.Show("查询结果为空！");
                    return;
                }

                DataTable dt1, dt2, dt3;
                dt1 = (DataTable)joRtn["output.appyinfo"].ToObject(typeof(DataTable));
                dt2 = (DataTable)joRtn["output.appyinfo.medInsuDirList"].ToObject(typeof(DataTable));
                dt3 = (DataTable)joRtn["output.appyinfo.fixmedinsList"].ToObject(typeof(DataTable));

                dgvAppyinfo.DataSource = dt1;
                dgvMedInsuDirList.DataSource = dt2;
                dgvFixmedinsList.DataSource = dt3;
            }
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            string outParam, errorMsg;
            //打开读卡窗口，操作员选择读卡类型后进行读卡器读卡，再进行1101获取参保信息
            if (hBus.readCard(out outParam) != 0)
            {
                MessageBox.Show("读卡失败：" + outParam);
                return;
            }

            //展示患者信息界面
            hBus.showPatInfo(outParam, out outParam);
            //赋值变量
            hBus.setGlobalPatAfaterShowPatInfo(outParam, out outParam);

            JObject joData = new JObject();
            JObject joInput = new JObject();
            joData.Add("psn_no", Global.pat.psn_no);
            joData.Add("begntime", dt_Begin.Text);
            joData.Add("endtime", dt_End.Text);
            joInput.Add("data", joData);

            JObject joRtn = invoker.invokeCenterService("5205", JsonHelper.setCenterInpar("5205", joInput));
            if (JsonHelper.parseCenterRtnValue(joRtn, out errorMsg) != 0)
            {
                MessageBox.Show(" 查询失败：" + errorMsg);
                return;
            }
            else
            {
                if (joRtn["output"]["feedetail"].ToString() == "[]")
                {
                    MessageBox.Show("查询结果为空！");
                    return;
                }

                dgvMain.DataSource = (DataTable)joRtn["output.feedetail"].ToObject(typeof(DataTable));
            }
        }

        private void uiButton3_Click(object sender, EventArgs e)
        {
            GridViewSetter grdSetter = new GridViewSetter();
            grdSetter.SetHeaderTextOfTraceCodeInfo(dgvtracecode);
            DateTime epochStart = new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc);
            long currentMillis = (long)((DateTime.UtcNow - epochStart).TotalMilliseconds);
            JObject JoI2002=new JObject();//追溯码关系关联接口
            //JObject JoZsm=new JObject();//追溯码            
            //JoZsm.Add("drugTracCodg", uiTextBox1.Text);//药品追溯码
            string zsm = "{'drugTracCodg':'" + uiTextBox1.Text + "'}";
            if (Global.inf.hospitalDr.ToString() == "18")
            {
                JoI2002.Add("isvEntId", "MTE0MjAxMDBNQjE1Mzc4NDZBNTk2YTZjNjg0ZTZhNTkzNTRkNmQ0ZDc0NGQ1MTNkM2Q");//辅助接口接入密钥武汉普瑞
                JoI2002.Add("refEntId", "SDQyMDEwNDAwMzY4XzIwMjQxMDExMTEyNjA2X2NkNWExMA");//辅助接口机构ID

            }
            else if (Global.inf.hospitalDr.ToString() == "20")
            {
                JoI2002.Add("isvEntId", "MTE0MjAxMDBNQjE1Mzc4NDZBNTk2YTZjNjg0ZTZhNTkzNTRkNmQ0ZDc0NGQ1MTNkM2Q");//辅助接口接入密钥湖北普瑞
                JoI2002.Add("refEntId", "SDQyMDExMTAzNDc1XzIwMjQxMDExMTEyNjA2XzEyNzUyZQ");//辅助接口机构ID
            }
            
            //JoI2002.Add("refEntId", Global.inf.hospitalNO);//辅助接口机构ID
            JoI2002.Add("t", currentMillis);//调用接口时的时间戳
            JoI2002.Add("data", zsm);//业务参数
            //JObject joRtn = invoker.invokeCenterServiceFZJK("I2002", JoI2002);
            JObject joRtn = invoker.invokeCenterServiceFZJK("I2002", JoI2002);
            //String Slstring = "{\r\n  \"code\": 0,\r\n  \"msg\": \"成功\",\r\n  \"data\": \"{\\\"drugTracCodg\\\":\\\"87609930004637290140\\\",\\\"pkgRatio\\\":\\\"1:28:280\\\",\\\"medListCodg\\\":\\\"XS01KAB146G010010179413\\\",\\\"codeRelationList\\\":[{\\\"code\\\":\\\"83520321286735335152\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458202398\\\"},{\\\"code\\\":\\\"83520321286735455862\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458202398\\\"},{\\\"code\\\":\\\"83520321286735574101\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458202398\\\"},{\\\"code\\\":\\\"83520321286734856365\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458202398\\\"},{\\\"code\\\":\\\"83520321286735693960\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458202398\\\"},{\\\"code\\\":\\\"83520321286735096370\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458202398\\\"},{\\\"code\\\":\\\"83520321286735214837\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458202398\\\"},{\\\"code\\\":\\\"83520321286735931358\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458202398\\\"},{\\\"code\\\":\\\"83520321286734970531\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458202398\\\"},{\\\"code\\\":\\\"83520321286735814977\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458202398\\\"},{\\\"code\\\":\\\"83520321289455581552\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458164790\\\"},{\\\"code\\\":\\\"83520321289455829871\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458164790\\\"},{\\\"code\\\":\\\"83520321289455705748\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458164790\\\"},{\\\"code\\\":\\\"83520321289455466048\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458164790\\\"},{\\\"code\\\":\\\"83520321289455102429\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458164790\\\"},{\\\"code\\\":\\\"83520321289456061777\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458164790\\\"},{\\\"code\\\":\\\"83520321289455345194\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458164790\\\"},{\\\"code\\\":\\\"83520321289456188141\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458164790\\\"},{\\\"code\\\":\\\"83520321289455944673\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458164790\\\"},{\\\"code\\\":\\\"83520321289455222912\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458164790\\\"},{\\\"code\\\":\\\"83520321286752492883\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458269392\\\"},{\\\"code\\\":\\\"83520321286752614372\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458269392\\\"},{\\\"code\\\":\\\"83520321286751657530\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458269392\\\"},{\\\"code\\\":\\\"83520321286752019747\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458269392\\\"},{\\\"code\\\":\\\"83520321286752139702\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458269392\\\"},{\\\"code\\\":\\\"83520321286751894168\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458269392\\\"},{\\\"code\\\":\\\"83520321286751776585\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458269392\\\"},{\\\"code\\\":\\\"83520321286752251192\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458269392\\\"},{\\\"code\\\":\\\"83520321286752731864\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458269392\\\"},{\\\"code\\\":\\\"83520321286752375309\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458269392\\\"},{\\\"code\\\":\\\"83520321289457865405\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458142860\\\"},{\\\"code\\\":\\\"83520321289458221781\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458142860\\\"},{\\\"code\\\":\\\"83520321289457988674\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458142860\\\"},{\\\"code\\\":\\\"83520321289458708814\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458142860\\\"},{\\\"code\\\":\\\"83520321289457626246\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458142860\\\"},{\\\"code\\\":\\\"83520321289458107896\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458142860\\\"},{\\\"code\\\":\\\"83520321289458582718\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458142860\\\"},{\\\"code\\\":\\\"83520321289458347038\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458142860\\\"},{\\\"code\\\":\\\"83520321289458460013\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458142860\\\"},{\\\"code\\\":\\\"83520321289457745815\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458142860\\\"},{\\\"code\\\":\\\"83520321286754294426\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458246493\\\"},{\\\"code\\\":\\\"83520321286754775191\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458246493\\\"},{\\\"code\\\":\\\"83520321286754651767\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458246493\\\"},{\\\"code\\\":\\\"83520321286755253146\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458246493\\\"},{\\\"code\\\":\\\"83520321286755016400\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458246493\\\"},{\\\"code\\\":\\\"83520321286754895223\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458246493\\\"},{\\\"code\\\":\\\"83520321286755133690\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458246493\\\"},{\\\"code\\\":\\\"83520321286754170545\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458246493\\\"},{\\\"code\\\":\\\"83520321286754415557\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458246493\\\"},{\\\"code\\\":\\\"83520321286754532808\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458246493\\\"},{\\\"code\\\":\\\"83520321286749854297\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458282248\\\"},{\\\"code\\\":\\\"83520321286750215194\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458282248\\\"},{\\\"code\\\":\\\"83520321286750331767\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458282248\\\"},{\\\"code\\\":\\\"83520321286749499373\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458282248\\\"},{\\\"code\\\":\\\"83520321286749618352\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458282248\\\"},{\\\"code\\\":\\\"83520321286749973735\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458282248\\\"},{\\\"code\\\":\\\"83520321286749250063\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458282248\\\"},{\\\"code\\\":\\\"83520321286749733332\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458282248\\\"},{\\\"code\\\":\\\"83520321286749375932\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458282248\\\"},{\\\"code\\\":\\\"83520321286750094405\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458282248\\\"},{\\\"code\\\":\\\"83520321286744690600\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458326929\\\"},{\\\"code\\\":\\\"83520321286744815582\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458326929\\\"},{\\\"code\\\":\\\"83520321286745295934\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458326929\\\"},{\\\"code\\\":\\\"83520321286745052812\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458326929\\\"},{\\\"code\\\":\\\"83520321286745175845\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458326929\\\"},{\\\"code\\\":\\\"83520321286771093538\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458326929\\\"},{\\\"code\\\":\\\"83520321286744936847\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458326929\\\"},{\\\"code\\\":\\\"83520321286770972308\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458326929\\\"},{\\\"code\\\":\\\"83520321286771210870\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458326929\\\"},{\\\"code\\\":\\\"83520321286770852399\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458326929\\\"},{\\\"code\\\":\\\"83520321286769412663\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458348163\\\"},{\\\"code\\\":\\\"83520321286768570892\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458348163\\\"},{\\\"code\\\":\\\"83520321286768811286\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458348163\\\"},{\\\"code\\\":\\\"83520321286769174831\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458348163\\\"},{\\\"code\\\":\\\"83520321286768454982\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458348163\\\"},{\\\"code\\\":\\\"83520321286769534345\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458348163\\\"},{\\\"code\\\":\\\"83520321286768693728\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458348163\\\"},{\\\"code\\\":\\\"83520321286768932572\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458348163\\\"},{\\\"code\\\":\\\"83520321286769291308\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458348163\\\"},{\\\"code\\\":\\\"83520321286769053362\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458348163\\\"},{\\\"code\\\":\\\"83520321286753818266\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458251182\\\"},{\\\"code\\\":\\\"83520321286753690112\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458251182\\\"},{\\\"code\\\":\\\"83520321286753335568\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458251182\\\"},{\\\"code\\\":\\\"83520321286753934497\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458251182\\\"},{\\\"code\\\":\\\"83520321286753093093\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458251182\\\"},{\\\"code\\\":\\\"83520321286753570836\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458251182\\\"},{\\\"code\\\":\\\"83520321286753217566\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458251182\\\"},{\\\"code\\\":\\\"83520321286752859150\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458251182\\\"},{\\\"code\\\":\\\"83520321286753455751\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458251182\\\"},{\\\"code\\\":\\\"83520321286754054985\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458251182\\\"},{\\\"code\\\":\\\"83520321289460028524\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458134538\\\"},{\\\"code\\\":\\\"83520321289459180386\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458134538\\\"},{\\\"code\\\":\\\"83520321289459666195\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458134538\\\"},{\\\"code\\\":\\\"83520321289459304355\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458134538\\\"},{\\\"code\\\":\\\"83520321289459060440\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458134538\\\"},{\\\"code\\\":\\\"83520321289458943298\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458134538\\\"},{\\\"code\\\":\\\"83520321289459425272\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458134538\\\"},{\\\"code\\\":\\\"83520321289459540269\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458134538\\\"},{\\\"code\\\":\\\"83520321289460147634\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458134538\\\"},{\\\"code\\\":\\\"83520321289458828991\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458134538\\\"},{\\\"code\\\":\\\"83520321286747819512\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458293040\\\"},{\\\"code\\\":\\\"83520321286749133208\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458293040\\\"},{\\\"code\\\":\\\"83520321286749012505\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458293040\\\"},{\\\"code\\\":\\\"83520321286748052014\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458293040\\\"},{\\\"code\\\":\\\"83520321286748171584\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458293040\\\"},{\\\"code\\\":\\\"83520321286748652523\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458293040\\\"},{\\\"code\\\":\\\"83520321286748530416\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458293040\\\"},{\\\"code\\\":\\\"83520321286748773464\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458293040\\\"},{\\\"code\\\":\\\"83520321286747938176\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458293040\\\"},{\\\"code\\\":\\\"83520321286748894792\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458293040\\\"},{\\\"code\\\":\\\"83520321286745659456\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458315413\\\"},{\\\"code\\\":\\\"83520321286746372824\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458315413\\\"},{\\\"code\\\":\\\"83520321286745774109\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458315413\\\"},{\\\"code\\\":\\\"83520321286745533670\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458315413\\\"},{\\\"code\\\":\\\"83520321286746131538\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458315413\\\"},{\\\"code\\\":\\\"83520321286746253611\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458315413\\\"},{\\\"code\\\":\\\"83520321286746015350\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458315413\\\"},{\\\"code\\\":\\\"83520321286745413642\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458315413\\\"},{\\\"code\\\":\\\"83520321286745899923\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458315413\\\"},{\\\"code\\\":\\\"83520321286746493132\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458315413\\\"},{\\\"code\\\":\\\"83520321289464349390\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458095377\\\"},{\\\"code\\\":\\\"83520321289464940003\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458095377\\\"},{\\\"code\\\":\\\"83520321289464702440\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458095377\\\"},{\\\"code\\\":\\\"83520321289464824056\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458095377\\\"},{\\\"code\\\":\\\"83520321289464584853\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458095377\\\"},{\\\"code\\\":\\\"83520321289463986284\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458095377\\\"},{\\\"code\\\":\\\"83520321289464104318\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458095377\\\"},{\\\"code\\\":\\\"83520321289464467172\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458095377\\\"},{\\\"code\\\":\\\"83520321289463860305\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458095377\\\"},{\\\"code\\\":\\\"83520321289464223489\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458095377\\\"},{\\\"code\\\":\\\"83520321289462541164\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458111048\\\"},{\\\"code\\\":\\\"83520321289461581241\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458111048\\\"},{\\\"code\\\":\\\"83520321289462301519\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458111048\\\"},{\\\"code\\\":\\\"83520321289462062241\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458111048\\\"},{\\\"code\\\":\\\"83520321289461702502\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458111048\\\"},{\\\"code\\\":\\\"83520321289461942238\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458111048\\\"},{\\\"code\\\":\\\"83520321289462424431\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458111048\\\"},{\\\"code\\\":\\\"83520321289461826220\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458111048\\\"},{\\\"code\\\":\\\"83520321289462180796\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458111048\\\"},{\\\"code\\\":\\\"83520321289461461497\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458111048\\\"},{\\\"code\\\":\\\"83520321289463502463\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458105400\\\"},{\\\"code\\\":\\\"83520321289462907815\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458105400\\\"},{\\\"code\\\":\\\"83520321289463749680\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458105400\\\"},{\\\"code\\\":\\\"83520321289462780727\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458105400\\\"},{\\\"code\\\":\\\"83520321289463025357\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458105400\\\"},{\\\"code\\\":\\\"83520321289463263333\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458105400\\\"},{\\\"code\\\":\\\"83520321289463148813\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458105400\\\"},{\\\"code\\\":\\\"83520321289463625460\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458105400\\\"},{\\\"code\\\":\\\"83520321289462663103\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458105400\\\"},{\\\"code\\\":\\\"83520321289463387393\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458105400\\\"},{\\\"code\\\":\\\"83520321289456306480\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458153961\\\"},{\\\"code\\\":\\\"83520321289457381213\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458153961\\\"},{\\\"code\\\":\\\"83520321289457144525\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458153961\\\"},{\\\"code\\\":\\\"83520321289456909103\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458153961\\\"},{\\\"code\\\":\\\"83520321289456667892\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458153961\\\"},{\\\"code\\\":\\\"83520321289456785243\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458153961\\\"},{\\\"code\\\":\\\"83520321289457507754\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458153961\\\"},{\\\"code\\\":\\\"83520321289456540214\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458153961\\\"},{\\\"code\\\":\\\"83520321289456426241\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458153961\\\"},{\\\"code\\\":\\\"83520321289457268003\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458153961\\\"},{\\\"code\\\":\\\"83520321289465780805\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458089550\\\"},{\\\"code\\\":\\\"83520321289465064596\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458089550\\\"},{\\\"code\\\":\\\"83520321289465301033\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458089550\\\"},{\\\"code\\\":\\\"83520321289465549525\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458089550\\\"},{\\\"code\\\":\\\"83520321289466145728\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458089550\\\"},{\\\"code\\\":\\\"83520321289466028079\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458089550\\\"},{\\\"code\\\":\\\"83520321289465424953\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458089550\\\"},{\\\"code\\\":\\\"83520321289465665186\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458089550\\\"},{\\\"code\\\":\\\"83520321289465903890\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458089550\\\"},{\\\"code\\\":\\\"83520321289465187964\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458089550\\\"},{\\\"code\\\":\\\"83520321286770491197\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458330407\\\"},{\\\"code\\\":\\\"83520321286770378279\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458330407\\\"},{\\\"code\\\":\\\"83520321286770251652\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458330407\\\"},{\\\"code\\\":\\\"83520321286770132643\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458330407\\\"},{\\\"code\\\":\\\"83520321286770613719\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458330407\\\"},{\\\"code\\\":\\\"83520321286770011004\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458330407\\\"},{\\\"code\\\":\\\"83520321286769650314\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458330407\\\"},{\\\"code\\\":\\\"83520321286769770902\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458330407\\\"},{\\\"code\\\":\\\"83520321286770735989\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458330407\\\"},{\\\"code\\\":\\\"83520321286769891621\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458330407\\\"},{\\\"code\\\":\\\"83520321286755371134\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458234831\\\"},{\\\"code\\\":\\\"83520321286755495656\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458234831\\\"},{\\\"code\\\":\\\"83520321286756457691\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458234831\\\"},{\\\"code\\\":\\\"83520321286756333873\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458234831\\\"},{\\\"code\\\":\\\"83520321286755978107\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458234831\\\"},{\\\"code\\\":\\\"83520321286756217356\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458234831\\\"},{\\\"code\\\":\\\"83520321286755730793\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458234831\\\"},{\\\"code\\\":\\\"83520321286755856179\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458234831\\\"},{\\\"code\\\":\\\"83520321286755613424\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458234831\\\"},{\\\"code\\\":\\\"83520321286756097508\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458234831\\\"},{\\\"code\\\":\\\"83520321286736417631\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458198335\\\"},{\\\"code\\\":\\\"83520321286736533253\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458198335\\\"},{\\\"code\\\":\\\"83520321286737130785\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458198335\\\"},{\\\"code\\\":\\\"83520321286736054364\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458198335\\\"},{\\\"code\\\":\\\"83520321286736294605\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458198335\\\"},{\\\"code\\\":\\\"83520321286736890246\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458198335\\\"},{\\\"code\\\":\\\"83520321286737011395\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458198335\\\"},{\\\"code\\\":\\\"83520321286736171104\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458198335\\\"},{\\\"code\\\":\\\"83520321286736659467\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458198335\\\"},{\\\"code\\\":\\\"83520321286736779376\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458198335\\\"},{\\\"code\\\":\\\"83520321286751172850\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458273826\\\"},{\\\"code\\\":\\\"83520321286751298408\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458273826\\\"},{\\\"code\\\":\\\"83520321286751054003\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458273826\\\"},{\\\"code\\\":\\\"83520321286750456187\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458273826\\\"},{\\\"code\\\":\\\"83520321286750696128\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458273826\\\"},{\\\"code\\\":\\\"83520321286750931795\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458273826\\\"},{\\\"code\\\":\\\"83520321286751535885\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458273826\\\"},{\\\"code\\\":\\\"83520321286751414523\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458273826\\\"},{\\\"code\\\":\\\"83520321286750573244\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458273826\\\"},{\\\"code\\\":\\\"83520321286750815089\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458273826\\\"},{\\\"code\\\":\\\"83520321289460869207\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458125999\\\"},{\\\"code\\\":\\\"83520321289460264480\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458125999\\\"},{\\\"code\\\":\\\"83520321289460629257\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458125999\\\"},{\\\"code\\\":\\\"83520321289460384192\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458125999\\\"},{\\\"code\\\":\\\"83520321289461222082\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458125999\\\"},{\\\"code\\\":\\\"83520321289460508056\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458125999\\\"},{\\\"code\\\":\\\"83520321289460981903\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458125999\\\"},{\\\"code\\\":\\\"83520321289461103827\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458125999\\\"},{\\\"code\\\":\\\"83520321289460742837\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458125999\\\"},{\\\"code\\\":\\\"83520321289461341368\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458125999\\\"},{\\\"code\\\":\\\"83520321289466267402\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458071788\\\"},{\\\"code\\\":\\\"83520321289467341013\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458071788\\\"},{\\\"code\\\":\\\"83520321289466509089\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458071788\\\"},{\\\"code\\\":\\\"83520321289466628670\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458071788\\\"},{\\\"code\\\":\\\"83520321289467225639\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458071788\\\"},{\\\"code\\\":\\\"83520321289466384391\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458071788\\\"},{\\\"code\\\":\\\"83520321289466984505\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458071788\\\"},{\\\"code\\\":\\\"83520321289466862737\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458071788\\\"},{\\\"code\\\":\\\"83520321289467107580\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458071788\\\"},{\\\"code\\\":\\\"83520321289466748688\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458071788\\\"},{\\\"code\\\":\\\"83520321286756817871\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458221468\\\"},{\\\"code\\\":\\\"83520321286756933580\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458221468\\\"},{\\\"code\\\":\\\"83520321286733415488\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458221468\\\"},{\\\"code\\\":\\\"83520321286733172884\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458221468\\\"},{\\\"code\\\":\\\"83520321286733059799\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458221468\\\"},{\\\"code\\\":\\\"83520321286757057489\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458221468\\\"},{\\\"code\\\":\\\"83520321286756695199\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458221468\\\"},{\\\"code\\\":\\\"83520321286733530965\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458221468\\\"},{\\\"code\\\":\\\"83520321286756572257\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458221468\\\"},{\\\"code\\\":\\\"83520321286757170309\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458221468\\\"},{\\\"code\\\":\\\"83520321286747575152\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458305840\\\"},{\\\"code\\\":\\\"83520321286747095833\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458305840\\\"},{\\\"code\\\":\\\"83520321286746974640\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458305840\\\"},{\\\"code\\\":\\\"83520321286747330815\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458305840\\\"},{\\\"code\\\":\\\"83520321286746858681\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458305840\\\"},{\\\"code\\\":\\\"83520321286747694287\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458305840\\\"},{\\\"code\\\":\\\"83520321286747456289\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458305840\\\"},{\\\"code\\\":\\\"83520321286746615282\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458305840\\\"},{\\\"code\\\":\\\"83520321286746733504\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458305840\\\"},{\\\"code\\\":\\\"83520321286747211566\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458305840\\\"},{\\\"code\\\":\\\"83520321286733892959\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458214219\\\"},{\\\"code\\\":\\\"83520321286733652391\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458214219\\\"},{\\\"code\\\":\\\"83520321286734254704\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458214219\\\"},{\\\"code\\\":\\\"83520321286734733360\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458214219\\\"},{\\\"code\\\":\\\"83520321286734610818\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458214219\\\"},{\\\"code\\\":\\\"83520321286733776252\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458214219\\\"},{\\\"code\\\":\\\"83520321286734374401\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458214219\\\"},{\\\"code\\\":\\\"83520321286734013434\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458214219\\\"},{\\\"code\\\":\\\"83520321286734135536\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458214219\\\"},{\\\"code\\\":\\\"83520321286734490978\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458214219\\\"},{\\\"code\\\":\\\"83520321286737494570\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458180548\\\"},{\\\"code\\\":\\\"83520321286737979546\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458180548\\\"},{\\\"code\\\":\\\"83520321286737370958\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458180548\\\"},{\\\"code\\\":\\\"83520321286737253882\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458180548\\\"},{\\\"code\\\":\\\"83520321286737853603\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458180548\\\"},{\\\"code\\\":\\\"83520321289453784395\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458180548\\\"},{\\\"code\\\":\\\"83520321286737614775\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458180548\\\"},{\\\"code\\\":\\\"83520321289453545597\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458180548\\\"},{\\\"code\\\":\\\"83520321286737735686\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458180548\\\"},{\\\"code\\\":\\\"83520321289453665042\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458180548\\\"},{\\\"code\\\":\\\"83520321289454740221\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458179347\\\"},{\\\"code\\\":\\\"83520321289454861521\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458179347\\\"},{\\\"code\\\":\\\"83520321289454626206\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458179347\\\"},{\\\"code\\\":\\\"83520321289454269948\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458179347\\\"},{\\\"code\\\":\\\"83520321289453908114\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458179347\\\"},{\\\"code\\\":\\\"83520321289454984355\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458179347\\\"},{\\\"code\\\":\\\"83520321289454506154\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458179347\\\"},{\\\"code\\\":\\\"83520321289454022919\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458179347\\\"},{\\\"code\\\":\\\"83520321289454382208\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458179347\\\"},{\\\"code\\\":\\\"83520321289454141017\\\",\\\"codeLevel\\\":3,\\\"codePackLevel\\\":1,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609940114458179347\\\"},{\\\"code\\\":\\\"87609940114458202398\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458164790\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458269392\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458142860\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458246493\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458282248\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458326929\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458348163\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458251182\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458134538\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458293040\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458315413\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458095377\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458111048\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458105400\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458153961\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458089550\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458330407\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458234831\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458198335\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458273826\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458125999\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458071788\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458221468\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458305840\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458214219\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458180548\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609940114458179347\\\",\\\"codeLevel\\\":2,\\\"codePackLevel\\\":2,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"87609930004637290140\\\"},{\\\"code\\\":\\\"87609930004637290140\\\",\\\"codeLevel\\\":1,\\\"codePackLevel\\\":3,\\\"status\\\":\\\"O\\\",\\\"parentCode\\\":\\\"\\\"}]}\",\r\n  \"t\": 1730697332396,\r\n  \"success\": true\r\n}";
            //JObject joRtn = JObject.Parse(Slstring);
            string Datastr = joRtn["data"].ToString();
            JObject Jodata = JObject.Parse(Datastr);            
            uiLabel3.Text = Jodata["pkgRatio"].ToString();
            uiTextBox2.Text = Jodata["medListCodg"].ToString();
            JArray Jarcodes = new JArray();
            Jarcodes =(JArray)Jodata["codeRelationList"];
            for(int i=0;  i<Jarcodes.Count; i++)
            {
                if (Jarcodes[i]["codeLevel"].ToString() =="1")
                {
                    Jarcodes[i]["codeLevel"] = "大包装码";
                }
                else if (Jarcodes[i]["codeLevel"].ToString() == "2")
                {
                    Jarcodes[i]["codeLevel"] = "中包装码";
                }
                else if (Jarcodes[i]["codeLevel"].ToString() == "3")
                {
                    Jarcodes[i]["codeLevel"] = "小包装码";
                }

                if (Jarcodes[i]["codePackLevel"].ToString() == "1")
                {
                    Jarcodes[i]["codePackLevel"] = "小包装码";
                }
                else if (Jarcodes[i]["codePackLevel"].ToString() == "2")
                {
                    Jarcodes[i]["codePackLevel"] = "中包装码";
                }
                else if (Jarcodes[i]["codePackLevel"].ToString() == "3")
                {
                    Jarcodes[i]["codePackLevel"] = "大包装码";
                }

            }
            dgvtracecode.DataSource = (DataTable)Jarcodes.ToObject(typeof(DataTable));
            //DataTable dt= (DataTable)Jarcodes.ToObject(typeof(DataTable));
            //dgvtracecode.DataSource = dt;


            ////拿到当前时间；
            //DateTime dateTime = DateTime.Now;
            ////存盘路径与存盘文件名；
            //SaveFileDialog saveFileDialog = new SaveFileDialog()
            //{
            //    Filter = "Excel File|*.xlsx",
            //    FileName = dateTime.ToString("yyyyMMdd_hhmm") + "统计"
            //};
            //if (saveFileDialog.ShowDialog() == DialogResult.OK)
            //{
            //    if (saveFileDialog.FileName == null) return;
            //    int a= EpplusToExcel.EPPlusExportDataGridviewToExcel(dgvtracecode, saveFileDialog);
            //    if (a != 0) {
            //        MessageBox.Show("导出失败！");
            //    }
            //    else
            //    {
            //        MessageBox.Show("导出成功！");
            //    }


        }
        private void DataToExcel()
        {

            string fileName = "";
            string saveFileName = "";
            SaveFileDialog saveDialog = new SaveFileDialog();
            saveDialog.DefaultExt = "xlsx";
            saveDialog.Filter = "Excel文件|*.xlsx";
            saveDialog.FileName = fileName;
            saveDialog.ShowDialog();
            saveFileName = saveDialog.FileName;

            if (saveFileName.IndexOf(":") < 0) return; //被点了取消
            Microsoft.Office.Interop.Excel.Application xlApp = new Microsoft.Office.Interop.Excel.Application();
            if (xlApp == null)
            {
                MessageBox.Show("无法创建Excel对象，您的电脑可能未安装Excel");
                return;
            }
            Microsoft.Office.Interop.Excel.Workbooks workbooks = xlApp.Workbooks;
            Microsoft.Office.Interop.Excel.Workbook workbook = workbooks.Add(Microsoft.Office.Interop.Excel.XlWBATemplate.xlWBATWorksheet);
            Microsoft.Office.Interop.Excel.Worksheet worksheet = (Microsoft.Office.Interop.Excel.Worksheet)workbook.Worksheets[1];//取得sheet1 
            //写入标题             
            for (int i = 0; i < dgvtracecode.ColumnCount; i++)
            { worksheet.Cells[1, i + 1] = dgvtracecode.Columns[i].HeaderText; }
            //写入数值
            for (int r = 0; r < dgvtracecode.Rows.Count; r++)
            {
                for (int i = 0; i < dgvtracecode.ColumnCount; i++)
                {
                    //if (i == 3)//将这一列有前导零的加上一个单引号
                    //{
                    //    worksheet.Cells[r + 2, i + 1] = "'" + dgv_Query.Rows[r].Cells[i].Value;
                    //    string temp = "'" + dgv_Query.Rows[r].Cells[i].Value;//看下值
                    //}
                    //else
                    //{
                    //    worksheet.Cells[r + 2, i + 1] = dgv_Query.Rows[r].Cells[i].Value;
                    //}
                    worksheet.Cells[r + 2, i + 1] = "'" + dgvtracecode.Rows[r].Cells[i].Value;

                }
                System.Windows.Forms.Application.DoEvents();
            }
            worksheet.Columns.EntireColumn.AutoFit();//列宽自适应
            MessageBox.Show(fileName + "资料保存成功", "提示", MessageBoxButtons.OK);
            if (saveFileName != "")
            {
                try
                {
                    workbook.Saved = true;
                    workbook.SaveCopyAs(saveFileName);  //fileSaved = true;                 
                }
                catch (Exception ex)
                {//fileSaved = false;                      
                    MessageBox.Show("导出文件时出错,文件可能正被打开！\n" + ex.Message);
                }
            }
            xlApp.Quit();
            GC.Collect();//强行销毁

        }

        private void uiButton4_Click(object sender, EventArgs e)
        {
            Thread t = new Thread(DataToExcel);

            t.IsBackground = true;

            //t.ApartmentState = ApartmentState.STA;//缺少这句话，就会出错误。


            //不过以上这句在Vs 2010中显示是被微软否决的，过时的，虽然还能用。但是为了更好的兼容版本，微软推出以下方法：


            t.SetApartmentState(ApartmentState.STA);　　//即是在线程启动时设置它的单元状态，这里设置它的状态为单线程单元




            t.Start();
        }
    }
}