﻿using PTMedicalInsurance.FormSetter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PTMedicalInsurance.Forms.Setters.ToPutOnRecord
{
    public class GridViewSetter : GridViewSetterBase
    {
        /// <summary>
        /// 设置HIS就诊信息列标题
        /// </summary>
        public void SetHeaderTextOfResult1(DataGridView dgv)
        {
            dgv.AutoGenerateColumns = false;
            dgv.Columns.Clear();
            AddDGVColumn(dgv, "人员编号", "psn_no", 300);
            //AddDGVColumn(dgv, "人员编号", "psn_no", 300);
            AddDGVColumn(dgv, "证件类型", "psn_cert_type", 300);
            AddDGVColumn(dgv, "证件号码", "certno", 300);
            AddDGVColumn(dgv, "医疗类别", "med_type", 300);
            AddDGVColumn(dgv, "定点医药机构编号", "fixmedins_code", 300);
            AddDGVColumn(dgv, "定点医药机构名称", "fixmedins_name", 300);
            AddDGVColumn(dgv, "病种编码", "dise_codg", 300);
            AddDGVColumn(dgv, "病种名称", "dise_name", 300);
            AddDGVColumn(dgv, "诊断编码", "diag_code", 300);
            AddDGVColumn(dgv, "诊断名称", "diag_name", 300);
            AddDGVColumn(dgv, "医保目录编码", "hilist_code", 300);
            AddDGVColumn(dgv, "医保目录名称", "hilist_name", 300);
            AddDGVColumn(dgv, "数量", "cnt", 300);
            AddDGVColumn(dgv, "剂型名称", "dosform_name", 300);
            AddDGVColumn(dgv, "规格", "spec", 300);
            AddDGVColumn(dgv, "单次剂量描述", "sin_dos_dscr", 300);
            AddDGVColumn(dgv, "使用频次描述", "used_frqu_dscr", 300);
            AddDGVColumn(dgv, "周期天数", "prd_days", 300);
            AddDGVColumn(dgv, "用药途径描述", "medc_way_dscr", 300);
            AddDGVColumn(dgv, "开始日期", "begndate", 300);
            AddDGVColumn(dgv, "结束日期", "enddate", 300);
            AddDGVColumn(dgv, "结算时间", "setl_time", 300);
            AddDGVColumn(dgv, "结算ID", "setl_id", 300);

        }

        /// <summary>
        /// 设置HIS就诊信息列标题
        /// </summary>
        public void SetHeaderTextOfApplyResult1(DataGridView dgv)
        {
            dgv.AutoGenerateColumns = false;
            dgv.Columns.Clear();
            AddDGVColumn(dgv, "人员编号", "PersonnelNO", 300);
            AddDGVColumn(dgv, "姓名", "PatientName", 300);
            AddDGVColumn(dgv, "待遇申报明细流水号", "DeclareNo", 300);
            AddDGVColumn(dgv, "备案类型", "RecordType", 300);
            AddDGVColumn(dgv, "备案状态", "RecordStatus", 300);
            AddDGVColumn(dgv, "险种类型", "Insutype", 300);
            AddDGVColumn(dgv, "电话", "Telephone", 300);
            AddDGVColumn(dgv, "地址", "Address", 300);
            AddDGVColumn(dgv, "参保机构医保区划", "InsuranceAreaCode", 300);
            AddDGVColumn(dgv, "业务医院编号", "BusinHospCode", 300);
            AddDGVColumn(dgv, "业务医院名称", "BusinHospDesc", 300);
            AddDGVColumn(dgv, "业务开始日期", "BusinStartDate", 300);
            AddDGVColumn(dgv, "业务结束日期", "BusinEndDate", 300);
            AddDGVColumn(dgv, "业务产生日期", "BusinDate", 300);
            AddDGVColumn(dgv, "诊断代码", "Diagcode", 300);
            AddDGVColumn(dgv, "诊断描述", "DiagDesc", 300);
            AddDGVColumn(dgv, "疾病病情描述", "DiseDesc", 300);
            AddDGVColumn(dgv, "就医地行政区划", "AreaCode", 300);
            AddDGVColumn(dgv, "医院同意转院标志", "HospAgreeFlag", 300);
            AddDGVColumn(dgv, "转院类型", "ReflType", 300);
            AddDGVColumn(dgv, "转院原因", "ReflReason", 300);
            AddDGVColumn(dgv, "转院意见", "ReflOpinion", 300);
            AddDGVColumn(dgv, "转诊使用标志", "ReflUsedFlag", 300);
            AddDGVColumn(dgv, "门慢门特病种目录代码", "ChronicDiseaseCode", 300);
            AddDGVColumn(dgv, "门慢门特病种名称", "ChronicDiseaseDesc", 300);
            AddDGVColumn(dgv, "诊断医师编码", "DoctorCode", 300);
            AddDGVColumn(dgv, "诊断医师姓名", "DoctorDesc", 300);
            AddDGVColumn(dgv, "业务申请类型", "BusinAppyType", 300);
            AddDGVColumn(dgv, "代办人姓名", "AgnterName", 300);
            AddDGVColumn(dgv, "代办人证件类型", "AgnterCertType", 300);
            AddDGVColumn(dgv, "代办人证件号码", "AgnterCertNo", 300);
            AddDGVColumn(dgv, "代办人联系方式", "AgnterTelephone", 300);
            AddDGVColumn(dgv, "代办人联系地址", "AgnterAddress", 300);
            AddDGVColumn(dgv, "代办人关系", "AgnterRelation", 300);
            AddDGVColumn(dgv, "定点排序号", "FixedNo", 300);
            AddDGVColumn(dgv, "备注", "Memo", 300);
            AddDGVColumn(dgv, "创建日期", "CreateDate", 300);
            AddDGVColumn(dgv, "创建人员", "CreateUser", 300);
            AddDGVColumn(dgv, "接口编号", "InterfaceDr", 300);

        }


    }
}
