﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using GMUtilLib;
using PTMedicalInsurance.Variables;
using Newtonsoft.Json.Linq;
using Newtonsoft.Json;
using SM2Crypto.Lib;
using PTMedicalInsurance.Common;


namespace PTMedicalInsurance.Helper
{
    class EncryptHelper
    {
        //武汉普瑞测试-医保移动支付-测试环境-微信
        //private string ak = "1H1INA1L90OH3F60C80A00008119D616";
        //private string sk = "APCIAgJqh3+AcK/IXL1WJD130i2q+6UblRxQzus3+sVw";
        //private string appid = "1HF6DJEV601A3F60C80A0000787DE1B9";
        //private string publicKey = "BDMsMM2HPRkaKSl2ynBbCRtJodP8Nh4G5IkEnV+7YHaCplkAZbPMsUlvJpWqQ+Q4sT7611xGSZ1/mPsqgqJ49zs=";  //平台公钥  验签

        //湖北普瑞测试-医保移动支付-测试环境-微信
        private string ak = "1HDV7J2GO0253F60C80A00006E005321";
        private string sk = "AJpBss2Mu+5k1uPrqcBo6xwSJe4jn8HoiJW7o9VnLjfe";
        private string appid = "1HDV7J2GI0243F60C80A0000C8D9A328";
        private string publicKey = "BHsnZMeTzSGwvWfnmf91ZIx1sAeN29gFSAshfslrrgo/NM/O59QPlmEHSTGlbyxce5kT61dUevTAwpFj2uX6j/E=";  //平台公钥  验签        

        ////兰州眼视光测试-医保移动支付-测试环境-微信
        //private string ak = "1HF6DJEVD01B3F60C80A0000659F707C";
        //private string sk = "AMLwcdEq2KM8hmJtREdiik4cw00dgPqA2GXB0uew/LJs";
        //private string appid = "1HF6DJEV601A3F60C80A0000787DE1B9";
        //private string publicKey = "BKBXP3QCHUwBUZgJ72rf4TUKnGN1FnE9pY5fSxHRwbhUEE/44CxCsHr026+PEIWC/TmRX5Z7uGgA9AKNIYAceBk=";  //平台公钥  验签

        ////兰州眼视光测试-医保移动支付-测试环境-支付宝
        //private string ak = "1GJG37E3S0L93F60C80A000054283D1E";
        //private string sk = "AdMyUwp+FFXfxtJ7dslvbs+vtFSb2FDKQ8eHtUSyyac=";
        //private string appid = "1GJG37E3M0L83F60C80A00009D4B001C";
        //private string publicKey = "BGMQ0mQ8DMOUYx4JBvwzFNHUesHnIjUe3f8lTnz+VeOZI8VU8LO0k3IyYXYz1hH2M6jBbpMC1T9IJnACNRGfMoU = ";  //平台公钥  验签

        //兰州眼视光正式
        //private string ak = "1H62Q1KH205K76430B0A0000BF149773";
        //private string sk = "YbNObZNMdUgwgLUEyK4ixNSkaCF9OPtCdDth9APWYKU=";
        //private string appid = "1H62Q1KGP05J76430B0A00007144E257";

        //昆明普瑞测试
        //private string ak = "1H1INA1L90OH3F60C80A00008119D616";
        //private string sk = "APCIAgJqh3+AcK/IXL1WJD130i2q+6UblRxQzus3+sVw";
        //private string appid = "1H1INA1L30OG3F60C80A0000DEE43558";

        //昆明普瑞正式
        //private string ak = "1H62Q1KH205K76430B0A0000BF149773";
        //private string sk = "YbNObZNMdUgwgLUEyK4ixNSkaCF9OPtCdDth9APWYKU=";
        //private string appid = "1H62Q1KGP05J76430B0A00007144E257";
        //ak:1H62Q1KH205K76430B0A0000BF149773;sk:YbNObZNMdUgwgLUEyK4ixNSkaCF9OPtCdDth9APWYKU=;appid:1H62Q1KGP05J76430B0A00007144E257

        /// <summary>
        /// 移动支付加密
        /// </summary>
        /// <param name="data"></param>
        /// <param name="signText"></param>
        /// <returns></returns>
        public string encrypt(string data, ref string signText)
        {
            string encryptData = "";
            try
            {
                string strData = JsonConvert.SerializeObject(JObject.Parse(data), Newtonsoft.Json.Formatting.None);
                encryptData = SignUtils.encryptMsg(Global.inf.appId, Global.inf.AK, Global.inf.SK, strData, ref signText);

                return encryptData;
            }
            catch (Exception ex)
            {
                encryptData = ex.Message;
                return encryptData;
            }
            finally
            {
                //Global.writeLog("ak:" + appSecret + ";sk:" + privateKey + ";appid:" + appId, data, encryptData);
            }
        }

        public string encrypt(string data)
        {
            string encryptData = "";
            try
            {
                encryptData = GMUtilLib.SignUtil.encryptMsg(Global.inf.appId, Global.inf.AK, Global.inf.SK, data);
                return encryptData;
            }
            catch (Exception ex)
            {
                encryptData = ex.Message;
                return encryptData;
            }
            finally
            {
                Global.writeLog("ak:" + Global.inf.AK + ";sk:" + Global.inf.SK + ";appid:" + Global.inf.appId, data, encryptData);
            }
        }

        public string sign(string data)
        {
            string encryptData = "";
            try
            {
                encryptData = GMUtilLib.SignUtil.signSm3WithSm2(Global.inf.appId, Global.inf.AK, Global.inf.SK, data);
                return encryptData;
            }
            catch (Exception ex)
            {
                encryptData = ex.Message;
                return encryptData;
            }
            finally
            {
                Global.writeLog("ak:" + Global.inf.AK + ";sk:" + Global.inf.SK + ";appid:" + Global.inf.appId, data, encryptData);
            }
        }

        public int verify(string data,string encryptData)
        {
            string error ="";
            try
            {
                if (GMUtilLib.SignUtil.verifySm3WithSm2(data, Global.inf.AK, encryptData, Global.inf.SK)) return 0;  else return -1;
            }
            catch (Exception ex)
            {
                error = ex.Message;
                return -1;
            }
            finally
            {
                Global.writeLog("ak:" + Global.inf.AK + ";sk:" + Global.inf.SK + ";appid:" + Global.inf.appId, data + ";" + encryptData, error);
            }
        }

        public bool verify(JObject signDto, string signData)
        {
            string error = "";
            try
            {
                bool b = SMUtil.verify(signDto, Global.inf.AK, Global.inf.publicKey, signData);
                if (b)
                {
                    error = "成功";
                }
                else
                {
                    error = "失败";
                }
                return b;
            }
            catch (Exception ex)
            {
                error = ex.Message;
                return false;
            }
            finally
            {
                Global.writeLog("验签：ak:" + Global.inf.AK + ";publicKey:" + Global.inf.publicKey + ";appid:" + Global.inf.appId, signDto.ToString() + ";" + signData, error);
            }
        }

        public string decrypt(string encryptData)
        {
            string data = "";
            try
            {
                data = GMUtilLib.SignUtil.decryptMsg(Global.inf.AK, Global.inf.SK, encryptData);
                return data;
            }
            catch (Exception ex)
            {
                data = ex.Message;
                return data;
            }
            finally
            {
                Global.writeLog("ak:" + Global.inf.AK + ";sk:" + Global.inf.SK + ";appid:" + Global.inf.appId, encryptData, data);
            }
        }

        public string decrypt00(string encryptData)
        {
            string data = "";
            try
            {
                data = SMUtil.decrypt(encryptData, Global.inf.appId, Global.inf.AK);
                return data;
            }
            catch (Exception ex)
            {
                data = ex.Message;
                return data;
            }
            finally
            {
                Global.writeLog("解密：ak:" + Global.inf.AK + ";sk:" + Global.inf.SK + ";appid:" + Global.inf.appId, encryptData, data);
            }
        }
    }
}
